Ruby: rb_vm_struct Struct Reference

Ruby 3.2.5p208 (2024-07-26 revision 31d0f1a2e7dbfb60731d1f05b868e1d578cda493)

Data Fields
rb_vm_struct Struct Reference

## Data Fields
VALUE | self
struct { |
struct ccan_list_head set |
unsigned int cnt |
unsigned int blocking_cnt |
struct rb_ractor_struct * main_ractor |
struct rb_thread_struct * main_thread |
struct { |
rb_nativethread_lock_t lock |
struct rb_ractor_struct * lock_owner |
unsigned int lock_rec |
bool barrier_waiting |
unsigned int barrier_cnt |
rb_nativethread_cond_t barrier_cond |
rb_nativethread_cond_t terminate_cond |
bool terminate_waiting |
} sync |
} | ractor |
rb_serial_t | fork_gen
rb_nativethread_lock_t | waitpid_lock
struct ccan_list_head | waiting_pids
struct ccan_list_head | waiting_grps
struct ccan_list_head | waiting_fds
volatile int | ubf_async_safe
unsigned int | running: 1
unsigned int | thread_abort_on_exception: 1
unsigned int | thread_report_on_exception: 1
unsigned int | thread_ignore_deadlock: 1
VALUE | mark_object_ary
const VALUE | special_exceptions [ruby_special_error_count]
rb_shape_t * | shape_list
rb_shape_t * | root_shape
shape_id_t | next_shape_id
VALUE | top_self
VALUE | load_path
VALUE | load_path_snapshot
VALUE | load_path_check_cache
VALUE | expanded_load_path
VALUE | loaded_features
VALUE | loaded_features_snapshot
VALUE | loaded_features_realpaths
VALUE | loaded_features_realpath_map
struct st_table * | loaded_features_index
struct st_table * | loading_table
struct st_table * | static_ext_inits
struct { |
VALUE cmd [RUBY_NSIG] |
} | trap_list |
struct st_table * | ensure_rollback_table
struct rb_postponed_job_struct * | postponed_job_buffer
rb_atomic_t | postponed_job_index
int | src_encoding_index
struct ccan_list_head | workqueue
rb_nativethread_lock_t | workqueue_lock
VALUE | orig_progname
VALUE | progname
VALUE | coverages
VALUE | me2counter
int | coverage_mode
st_table * | defined_module_hash
struct rb_objspace * | objspace
rb_at_exit_list * | at_exit
st_table * | frozen_strings
const struct rb_builtin_function * | builtin_function_table
int | builtin_inline_index
struct rb_id_table * | negative_cme_table
st_table * | overloaded_cme_table
struct rb_id_table * | constant_cache
const struct rb_callcache * | global_cc_cache_table [VM_GLOBAL_CC_CACHE_TABLE_SIZE]
struct { |
size_t thread_vm_stack_size |
size_t thread_machine_stack_size |
size_t fiber_vm_stack_size |
size_t fiber_machine_stack_size |
} | default_params |

## Detailed Description

Definition at line 615 of file vm_core.h.

## Field Documentation

## ◆ at_exit

rb_at_exit_list* rb_vm_struct::at_exit

Definition at line 712 of file vm_core.h.

## ◆ barrier_cnt

unsigned int rb_vm_struct::barrier_cnt

Definition at line 634 of file vm_core.h.

## ◆ barrier_cond

rb_nativethread_cond_t rb_vm_struct::barrier_cond

Definition at line 635 of file vm_core.h.

## ◆ barrier_waiting

bool rb_vm_struct::barrier_waiting

Definition at line 633 of file vm_core.h.

## ◆ blocking_cnt

unsigned int rb_vm_struct::blocking_cnt

Definition at line 621 of file vm_core.h.

## ◆ builtin_function_table

const struct rb_builtin_function* rb_vm_struct::builtin_function_table

Definition at line 716 of file vm_core.h.

## ◆ builtin_inline_index

int rb_vm_struct::builtin_inline_index

Definition at line 717 of file vm_core.h.

## ◆ cmd

VALUE rb_vm_struct::cmd[RUBY_NSIG]

Definition at line 688 of file vm_core.h.

## ◆ cnt

unsigned int rb_vm_struct::cnt

Definition at line 620 of file vm_core.h.

## ◆ constant_cache

struct rb_id_table* rb_vm_struct::constant_cache

Definition at line 726 of file vm_core.h.

## ◆ coverage_mode

int rb_vm_struct::coverage_mode

Definition at line 706 of file vm_core.h.

## ◆ coverages

VALUE rb_vm_struct::coverages

Definition at line 705 of file vm_core.h.

## ◆ defined_module_hash

st_table* rb_vm_struct::defined_module_hash

Definition at line 708 of file vm_core.h.

## ◆ ensure_rollback_table

struct st_table* rb_vm_struct::ensure_rollback_table

Definition at line 692 of file vm_core.h.

## ◆ expanded_load_path

VALUE rb_vm_struct::expanded_load_path

Definition at line 675 of file vm_core.h.

## ◆ fiber_machine_stack_size

size_t rb_vm_struct::fiber_machine_stack_size

Definition at line 742 of file vm_core.h.

## ◆ fiber_vm_stack_size

size_t rb_vm_struct::fiber_vm_stack_size

Definition at line 741 of file vm_core.h.

## ◆ fork_gen

rb_serial_t rb_vm_struct::fork_gen

Definition at line 647 of file vm_core.h.

## ◆ frozen_strings

st_table* rb_vm_struct::frozen_strings

Definition at line 714 of file vm_core.h.

## ◆ global_cc_cache_table

const struct rb_callcache* rb_vm_struct::global_cc_cache_table[VM_GLOBAL_CC_CACHE_TABLE_SIZE]

Definition at line 731 of file vm_core.h.

## ◆ load_path

VALUE rb_vm_struct::load_path

Definition at line 672 of file vm_core.h.

## ◆ load_path_check_cache

VALUE rb_vm_struct::load_path_check_cache

Definition at line 674 of file vm_core.h.

## ◆ load_path_snapshot

VALUE rb_vm_struct::load_path_snapshot

Definition at line 673 of file vm_core.h.

## ◆ loaded_features

VALUE rb_vm_struct::loaded_features

Definition at line 676 of file vm_core.h.

## ◆ loaded_features_index

struct st_table* rb_vm_struct::loaded_features_index

Definition at line 680 of file vm_core.h.

## ◆ loaded_features_realpath_map

VALUE rb_vm_struct::loaded_features_realpath_map

Definition at line 679 of file vm_core.h.

## ◆ loaded_features_realpaths

VALUE rb_vm_struct::loaded_features_realpaths

Definition at line 678 of file vm_core.h.

## ◆ loaded_features_snapshot

VALUE rb_vm_struct::loaded_features_snapshot

Definition at line 677 of file vm_core.h.

## ◆ loading_table

struct st_table* rb_vm_struct::loading_table

Definition at line 681 of file vm_core.h.

## ◆ lock

rb_nativethread_lock_t rb_vm_struct::lock

Definition at line 628 of file vm_core.h.

## ◆ lock_owner

struct rb_ractor_struct* rb_vm_struct::lock_owner

Definition at line 629 of file vm_core.h.

## ◆ lock_rec

unsigned int rb_vm_struct::lock_rec

Definition at line 630 of file vm_core.h.

## ◆ main_ractor

struct rb_ractor_struct* rb_vm_struct::main_ractor

Definition at line 623 of file vm_core.h.

## ◆ main_thread

struct rb_thread_struct* rb_vm_struct::main_thread

Definition at line 624 of file vm_core.h.

## ◆ mark_object_ary

VALUE rb_vm_struct::mark_object_ary

Definition at line 662 of file vm_core.h.

## ◆ me2counter

VALUE rb_vm_struct::me2counter

Definition at line 705 of file vm_core.h.

## ◆ negative_cme_table

struct rb_id_table* rb_vm_struct::negative_cme_table

Definition at line 719 of file vm_core.h.

## ◆ next_shape_id

shape_id_t rb_vm_struct::next_shape_id

Definition at line 668 of file vm_core.h.

## ◆ objspace

struct rb_objspace* rb_vm_struct::objspace

Definition at line 710 of file vm_core.h.

## ◆ orig_progname

VALUE rb_vm_struct::orig_progname

Definition at line 704 of file vm_core.h.

## ◆ overloaded_cme_table

st_table* rb_vm_struct::overloaded_cme_table

Definition at line 720 of file vm_core.h.

## ◆ postponed_job_buffer

struct rb_postponed_job_struct* rb_vm_struct::postponed_job_buffer

Definition at line 695 of file vm_core.h.

## ◆ postponed_job_index

rb_atomic_t rb_vm_struct::postponed_job_index

Definition at line 696 of file vm_core.h.

## ◆ progname

VALUE rb_vm_struct::progname

Definition at line 704 of file vm_core.h.

## ◆ root_shape

rb_shape_t* rb_vm_struct::root_shape

Definition at line 667 of file vm_core.h.

## ◆ running

unsigned int rb_vm_struct::running

Definition at line 656 of file vm_core.h.

## ◆ self

VALUE rb_vm_struct::self

Definition at line 616 of file vm_core.h.

## ◆ set

struct ccan_list_head rb_vm_struct::set

Definition at line 619 of file vm_core.h.

## ◆ shape_list

rb_shape_t* rb_vm_struct::shape_list

Definition at line 666 of file vm_core.h.

## ◆ special_exceptions

const VALUE rb_vm_struct::special_exceptions[ruby_special_error_count]

Definition at line 663 of file vm_core.h.

## ◆ src_encoding_index

int rb_vm_struct::src_encoding_index

Definition at line 698 of file vm_core.h.

## ◆ static_ext_inits

struct st_table* rb_vm_struct::static_ext_inits

Definition at line 684 of file vm_core.h.

## ◆ terminate_cond

rb_nativethread_cond_t rb_vm_struct::terminate_cond

Definition at line 638 of file vm_core.h.

## ◆ terminate_waiting

bool rb_vm_struct::terminate_waiting

Definition at line 639 of file vm_core.h.

## ◆ thread_abort_on_exception

unsigned int rb_vm_struct::thread_abort_on_exception

Definition at line 657 of file vm_core.h.

## ◆ thread_ignore_deadlock

unsigned int rb_vm_struct::thread_ignore_deadlock

Definition at line 659 of file vm_core.h.

## ◆ thread_machine_stack_size

size_t rb_vm_struct::thread_machine_stack_size

Definition at line 740 of file vm_core.h.

## ◆ thread_report_on_exception

unsigned int rb_vm_struct::thread_report_on_exception

Definition at line 658 of file vm_core.h.

## ◆ thread_vm_stack_size

size_t rb_vm_struct::thread_vm_stack_size

Definition at line 739 of file vm_core.h.

## ◆ top_self

VALUE rb_vm_struct::top_self

Definition at line 671 of file vm_core.h.

## ◆ ubf_async_safe

volatile int rb_vm_struct::ubf_async_safe

Definition at line 654 of file vm_core.h.

## ◆ waiting_fds

struct ccan_list_head rb_vm_struct::waiting_fds

Definition at line 651 of file vm_core.h.

## ◆ waiting_grps

struct ccan_list_head rb_vm_struct::waiting_grps

Definition at line 650 of file vm_core.h.

## ◆ waiting_pids

struct ccan_list_head rb_vm_struct::waiting_pids

Definition at line 649 of file vm_core.h.

## ◆ waitpid_lock

rb_nativethread_lock_t rb_vm_struct::waitpid_lock

Definition at line 648 of file vm_core.h.

## ◆ workqueue

struct ccan_list_head rb_vm_struct::workqueue

Definition at line 701 of file vm_core.h.

## ◆ workqueue_lock

rb_nativethread_lock_t rb_vm_struct::workqueue_lock

Definition at line 702 of file vm_core.h.

The documentation for this struct was generated from the following file:

- vm_core.h